<template>
    <div class="expert-list-item" :class="validationMsgClass" :id="id">
        <span class="expert-list-item__title">{{title}}</span>
        <span class="expert-list-item__value">
            <edit-switcher ref="switcher" :isEditable="canEdit" :editedValue="editedValue" :edit-config="config"
                @edit="checkActiveEdit">
                    <template v-slot:editable="{ edit }">
                        <template v-if="!edit.active">
                            <n-a v-if="isNA" />
                            <span v-else-if="isStatusIcon">
                                <i :class="value | status_icon"></i>
                            </span>
                            <router-link v-else-if="config.route" :to="routerLink" class="link">{{formatedValue}}</router-link>
                            <span v-else-if="isTags">
                                <tags :items="dictionaryLabels" size="medium" />
                            </span>
                            <html-viewer v-else-if="isHtml" :value="value" class="rich_editor" />
                            <image-viewer v-else-if="isImage" :src="value" :alt="value" previewWidth="14rem" />
                            <span v-else class="word_break">{{formatedValue}}</span>
                        </template>
                        <dynamic-control ref="control" v-else :config="edit" :id="id" :init-value="value" v-model="editValue"
                            minWidth="0" max-width="50rem" @validated="checkValidation" @focus="onFocus"
                            :is-invalid="validationParams.invalid" :invalid-msg="validationParams.message" />
                    </template>
            </edit-switcher>
        </span>
    </div>
</template>

<script>
import {
    IMAGE_VIEWER, TAGS, STATUS_ICON, HTML_VIEWER,
} from '@/constants/ui/details';
import { ImageViewer } from '@/components/MediaViewer';
import NA from '@bloomio/spa-admin-common/components/no-answer';
import DynamicControl from '@/components/DynamicControl';
import Tags from '@/components/Tags';
import HtmlViewer from '@/components/HtmlViewer';
import EditSwitcher from '@/components/EditSwitcher';
import validationMixin from '@bloomio/spa-admin-common/mixins/validationMixin';

export default {
    name: 'DetailsParamItem',
    components: {
        EditSwitcher,
        DynamicControl,
        NA,
        Tags,
        ImageViewer,
        HtmlViewer,
    },
    mixins: [validationMixin],
    created() {
        this.editValue = this.editedValue ? this.editedValue.value : this.value;
    },
    watch: {
        editValue(newVal, oldValue) {
            if (this.validationParams.invalid) {
                this.$store.commit('clearValidationMessage', this.id);
            }
            if (newVal !== this.value) {
                this.$store.commit('experts/setParamValue', { id: this.id, value: newVal });
            } else if (oldValue !== null) {
                this.$store.commit('experts/clearParamValue', this.id);
                this.$store.commit('clearBlockSubmitById', this.id);
            }
        },
        validationParams(newVal) {
            if (newVal.invalid) {
                this.$refs.switcher.switchEditMode({ status: true });
            }
        },
    },
    props: {
        id: { // param id
            type: [String, Object],
            required: false,
        },
        value: { // param value from server
            type: null,
            required: false,
        },
        config: { // edit mode settings
            type: Object,
            required: false,
            default: () => {},
        },
    },
    data() {
        return {
            editValue: null,
            isActiveEditMode: false,
        };
    },
    computed: {
        title: vm => vm.config.title,
        canEdit: vm => vm.$store.getters['experts/isEditableFIeld'](vm.id),
        isNA: vm => (vm.value === '' || vm.value === null || vm.value === undefined || (Array.isArray(vm.value) && !vm.value.length)),
        editedValue: vm => vm.$store.getters['experts/isParamEdited'](vm.id),
        isStatusIcon: vm => vm.config.readFormat === STATUS_ICON,
        isTags: vm => vm.config.readFormat === TAGS,
        isImage: vm => vm.config && vm.config.readFormat === IMAGE_VIEWER,
        isHtml: vm => vm.config && vm.config.readFormat === HTML_VIEWER,
        formatedValue: vm => (vm.config && vm.config.filter ? vm.$filters[vm.config.filter](vm.value) : vm.value),
        dictionaryLabels: vm => vm.config.dictionaryArray.reduce((acc, { label, value }) => {
            if (vm.value.includes(value)) {
                acc.push(label);
            }
            return acc;
        }, []),
        routerLink: vm => ({ name: vm.config.route.name, params: vm.config.route.params }),
        blockSubmit: vm => vm.config.inputAction && vm.config.inputAction.blockSubmit,
    },
    methods: {
        /**
         * Disable edit mode
         */
        disableEditMode() {
            if (this.editedValue) {
                this.$refs.switcher.switchEditMode({ status: false });
            }
        },
        /**
         * Reset edited value on deactivating edit-mode
         * @param {Object} event - emited event data
         */
        checkActiveEdit(event) {
            this.isActiveEditMode = Boolean(event.active);
            if (!event.active) {
                if (this.editValue === this.value) {
                    this.$store.commit('experts/clearParamValue', this.id);
                } else {
                    this.editValue = this.value;
                }
            }
        },
        /**
         * Set validation answer for the parameter and flag to block submit button into vuex store
         * @param {Object} data - emited from dynamic control validation setting
         */
        checkValidation(data) {
            if (this.blockSubmit) {
                this.$store.commit('blockSubmit', data);
            }
            this.$store.commit('setValidationMessages', { data: { [data.id]: { value: data.value, message: data.message, invalid: data.invalid } } });
        },
        /**
         * Set default value for the control if have empty server data for the parameter (need for URI field)
         */
        onFocus() {
            if (this.isActiveEditMode && this.config.defaultValue && !this.editValue) {
                this.editValue = this.config.defaultValue;
                if (this.$refs.control) {
                    this.$refs.control.validate(this.editValue);
                }
            }
        },
    },
};
</script>

<style lang="stylus" scoped>
.expert-list-item
    display: flex
    align-items: center
    font-size: 1.6rem
    margin: .7rem 0
    padding: .3rem 0
    max-width: 100rem
    word-break: break-all

.expert-list-item.is-invalid
    background: rgba($base_red, 0.3)

.expert-list-item:hover
    background-color: rgba(0, 0, 0, .02)

.expert-list-item__title
    padding-left: 1rem
    font-family: RobotoSlabRegular
    font-weight: 600
    max-width: 17rem
    min-width: 0
    width: 100%
    margin-right: 1rem

.expert-list-item__value
    width: 100%

.expert-list-item__value-noedit
    padding: .5rem 1rem

</style>

<style lang="stylus">
@import '../../assets/styles/rich_editor.styl'
</style>
